VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "BreakCodeLines []"
   ClientHeight    =   7485
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   10365
   LinkTopic       =   "Form1"
   ScaleHeight     =   7485
   ScaleWidth      =   10365
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtMaxLength 
      Height          =   285
      Left            =   1080
      TabIndex        =   4
      Text            =   "50"
      Top             =   960
      Width           =   615
   End
   Begin MSComDlg.CommonDialog dlgFile 
      Left            =   2280
      Top             =   240
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdFormat 
      Caption         =   "Format"
      Enabled         =   0   'False
      Height          =   375
      Left            =   2040
      TabIndex        =   2
      Top             =   960
      Width           =   735
   End
   Begin VB.TextBox txtResult 
      BackColor       =   &H00C0C0C0&
      Height          =   855
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   1
      Top             =   1440
      Width           =   1695
   End
   Begin VB.TextBox txtInput 
      Height          =   735
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   120
      Width           =   1695
   End
   Begin VB.Label lblMaxLength 
      Caption         =   "Line Length"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   960
      Width           =   855
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open"
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileSaveAs 
         Caption         =   "Save &As..."
         Enabled         =   0   'False
         Shortcut        =   ^A
      End
      Begin VB.Menu mnuFileExitSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Break the code line so it isn't too long.
Private Function BreakCodeLine(ByVal code_line As String, ByVal max_len As Integer) As String
Dim indent As String
Dim good_space As Long
Dim result As String
Dim quote_open As Boolean
Dim comment_open As Boolean
Dim j As Long
Dim ch As String
Dim min_length As Integer

    ' See how much the line is indented.
    indent = Space$(Len(code_line) - Len(Trim$(code_line)))

    ' If this line is not a comment, indent subsequent lines.
    If Left$(Trim$(code_line), 1) <> "'" Then
        indent = indent + Space$(4)
    End If

    ' Don't break within this many characters of
    ' the start of the string.
    min_length = Len(indent) + 4

    ' Trim the line until it fits.
    Do While Len(code_line) > max_len
        ' Find the space closest to the maximum character.
        good_space = InStrRev(code_line, " ", max_len)

        ' Do not break too soon.
        If good_space <= min_length Then good_space = 0

        ' If there are no spaces before MAX_LEN, look after.
        If good_space = 0 Then
            good_space = InStr(max_len, code_line, " ")
        End If

        If good_space = 0 Then
            ' No good spaces. Display the rest at once.
            Exit Do
        Else
            ' Break at this space.
            ' See if the space is in a quoted string or comment.
            comment_open = False
            quote_open = False
            For j = 1 To good_space
                ch = Mid$(code_line, j, 1)
                If ch = "'" Then
                    If Not quote_open Then comment_open = True
                ElseIf ch = """" Then
                    quote_open = Not quote_open
                End If
            Next j

            If comment_open Then
                ' The space is in a comment.
                ' Start the new line with a comment.
                result = result & vbCrLf & _
                    Left$(code_line, good_space - 1)
                code_line = indent & "' " & _
                    Trim$(Mid$(code_line, good_space))
            ElseIf quote_open Then
                ' The space is in a quoted string.
                ' Break the string.
                result = result & vbCrLf & _
                    Left$(code_line, good_space) & """ & _"
                code_line = indent & """" & _
                    Mid$(code_line, good_space + 1)
            Else
                ' The space is within code.
                ' Break the code.
                result = result & vbCrLf & _
                    Left$(code_line, good_space - 1) & " _"
                code_line = indent & _
                    Trim$(Mid$(code_line, good_space))
            End If
        End If
    Loop

    ' Add the last piece of code.
    result = result & vbCrLf & code_line

    If Len(result) > 0 Then
        BreakCodeLine = Mid$(result, Len(vbCrLf) + 1)
    Else
        BreakCodeLine = result
    End If
End Function

' Break all of the code's lines.
Public Function BreakCodeLines(ByVal code As String, ByVal max_len As Integer) As String
Dim lines As Variant
Dim i As Integer
Dim result As String

    ' Break the code into lines.
    lines = Split(code, vbCrLf)

    ' Break the lines.
    For i = LBound(lines) To UBound(lines)
        result = result & vbCrLf & BreakCodeLine(lines(i), max_len)
    Next i

    ' Remove the leading vbCrLf.
    If Len(result) > 0 Then result = Mid$(result, Len(vbCrLf) + 1)

    ' Return the result.
    BreakCodeLines = result
End Function
' Format the code.
Private Sub cmdFormat_Click()
    On Error GoTo FormatError
    txtResult.Text = BreakCodeLines(txtInput.Text, CInt(txtMaxLength.Text))
    mnuFileSaveAs.Enabled = True
    Exit Sub

FormatError:
    MsgBox "Error " & Err.Number & " formatting code." & _
        vbCrLf & Err.Description, _
        vbCritical, "Format Error"
    Exit Sub
End Sub

Private Sub Form_Load()
    dlgFile.CancelError = True
    dlgFile.Filter = _
        "VB Files (*.vb;*.bas;*.frm;*.ctl;*.cls)|*.vb;*.bas;*.frm;*.ctl;*.cls|" & _
        "Text Files (*.txt)|*.txt|" & _
        "All Files (*.*)|*.*"
    dlgFile.FilterIndex = 0
    dlgFile.InitDir = App.Path
End Sub

Private Sub Form_Resize()
Const GAP = 30
Dim hgt As Single

    hgt = (ScaleHeight - cmdFormat.Height - 2 * GAP) / 2
    If hgt < 120 Then hgt = 120
    txtInput.Move 0, 0, ScaleWidth, hgt
    lblMaxLength.Top = hgt + GAP
    txtMaxLength.Top = hgt + GAP
    cmdFormat.Top = hgt + GAP
    txtResult.Move 0, hgt + 2 * GAP + cmdFormat.Height, ScaleWidth, hgt
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub


Private Sub mnuFileOpen_Click()
    dlgFile.Flags = _
        cdlOFNFileMustExist Or _
        cdlOFNHideReadOnly Or _
        cdlOFNExplorer
    On Error Resume Next
    dlgFile.ShowOpen
    If Err.Number = cdlCancel Then
        ' The user canceled.
        Exit Sub
    ElseIf Err.Number <> 0 Then
        ' Unexpected error.
        MsgBox "Error " & Err.Number & " selecting file." & _
            vbCrLf & Err.Description, _
            vbCritical, "File Select Error"
        Exit Sub
    End If

    ' Load the file.
    UpdateInitDir dlgFile
    txtInput.Text = LoadFile(dlgFile.FileName)
    If Err.Number <> 0 Then
        MsgBox "Error " & Err.Number & " loading file." & _
            vbCrLf & Err.Description, _
            vbCritical, "Save Error"
        Exit Sub
    End If

    cmdFormat.Enabled = True
End Sub
Private Sub mnuFileSaveAs_Click()
    dlgFile.Flags = _
        cdlOFNOverwritePrompt Or _
        cdlOFNHideReadOnly Or _
        cdlOFNExplorer
    On Error Resume Next
    dlgFile.ShowSave
    If Err.Number = cdlCancel Then
        ' The user canceled.
        Exit Sub
    ElseIf Err.Number <> 0 Then
        ' Unexpected error.
        MsgBox "Error " & Err.Number & " selecting file." & _
            vbCrLf & Err.Description, _
            vbCritical, "File Select Error"
        Exit Sub
    End If

    ' Save the file.
    UpdateInitDir dlgFile
    SaveFile dlgFile.FileName, txtResult.Text
    If Err.Number <> 0 Then
        MsgBox "Error " & Err.Number & " saving file." & _
            vbCrLf & Err.Description, _
            vbCritical, "Save Error"
        Exit Sub
    End If
End Sub
